# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class ServerConfigSignup(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'allowed': 'bool',
        'allowed_for_current_ip': 'bool',
        'requires_email_verification': 'bool'
    }

    attribute_map = {
        'allowed': 'allowed',
        'allowed_for_current_ip': 'allowedForCurrentIP',
        'requires_email_verification': 'requiresEmailVerification'
    }

    def __init__(self, allowed=None, allowed_for_current_ip=None, requires_email_verification=None, local_vars_configuration=None):  # noqa: E501
        """ServerConfigSignup - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._allowed = None
        self._allowed_for_current_ip = None
        self._requires_email_verification = None
        self.discriminator = None

        if allowed is not None:
            self.allowed = allowed
        if allowed_for_current_ip is not None:
            self.allowed_for_current_ip = allowed_for_current_ip
        if requires_email_verification is not None:
            self.requires_email_verification = requires_email_verification

    @property
    def allowed(self):
        """Gets the allowed of this ServerConfigSignup.  # noqa: E501


        :return: The allowed of this ServerConfigSignup.  # noqa: E501
        :rtype: bool
        """
        return self._allowed

    @allowed.setter
    def allowed(self, allowed):
        """Sets the allowed of this ServerConfigSignup.


        :param allowed: The allowed of this ServerConfigSignup.  # noqa: E501
        :type allowed: bool
        """

        self._allowed = allowed

    @property
    def allowed_for_current_ip(self):
        """Gets the allowed_for_current_ip of this ServerConfigSignup.  # noqa: E501


        :return: The allowed_for_current_ip of this ServerConfigSignup.  # noqa: E501
        :rtype: bool
        """
        return self._allowed_for_current_ip

    @allowed_for_current_ip.setter
    def allowed_for_current_ip(self, allowed_for_current_ip):
        """Sets the allowed_for_current_ip of this ServerConfigSignup.


        :param allowed_for_current_ip: The allowed_for_current_ip of this ServerConfigSignup.  # noqa: E501
        :type allowed_for_current_ip: bool
        """

        self._allowed_for_current_ip = allowed_for_current_ip

    @property
    def requires_email_verification(self):
        """Gets the requires_email_verification of this ServerConfigSignup.  # noqa: E501


        :return: The requires_email_verification of this ServerConfigSignup.  # noqa: E501
        :rtype: bool
        """
        return self._requires_email_verification

    @requires_email_verification.setter
    def requires_email_verification(self, requires_email_verification):
        """Sets the requires_email_verification of this ServerConfigSignup.


        :param requires_email_verification: The requires_email_verification of this ServerConfigSignup.  # noqa: E501
        :type requires_email_verification: bool
        """

        self._requires_email_verification = requires_email_verification

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServerConfigSignup):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ServerConfigSignup):
            return True

        return self.to_dict() != other.to_dict()
